> For clean Markdown content of this page, append .md to this URL. For the complete documentation index, see https://learning.postman.com/llms.txt. For full content including API reference and SDK examples, see https://learning.postman.com/llms-full.txt.

# Sync collection with spec

PUT https://api.getpostman.com/collections/{collectionUid}/synchronizations

Syncs a collection generated from an API specification. This is an asynchronous endpoint that returns an HTTP `202 Accepted` response.

**Note:**

- This endpoint only supports the OpenAPI 2.0, 3.0, and 3.1 specification types.
- You can only sync collections generated from the given spec ID.


Reference: https://learning.postman.com/api-docs/api-reference/specs/sync-collection-with-spec

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: Postman API
  version: 1.0.0
paths:
  /collections/{collectionUid}/synchronizations:
    put:
      operationId: syncCollectionWithSpec
      summary: Sync collection with spec
      description: >
        Syncs a collection generated from an API specification. This is an
        asynchronous endpoint that returns an HTTP `202 Accepted` response.


        **Note:**


        - This endpoint only supports the OpenAPI 2.0, 3.0, and 3.1
        specification types.

        - You can only sync collections generated from the given spec ID.
      tags:
        - specs
      parameters:
        - name: collectionUid
          in: path
          description: The collection's unique ID.
          required: true
          schema:
            $ref: '#/components/schemas/collectionUid'
        - name: specId
          in: query
          description: The spec's ID.
          required: true
          schema:
            $ref: '#/components/schemas/specId'
        - name: x-api-key
          in: header
          required: true
          schema:
            type: string
      responses:
        '202':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/generateTaskResponse'
        '403':
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/SyncCollectionWithSpecRequestForbiddenError
        '404':
          description: Not Found
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/commonErrorTypeTitleDetailStatus'
servers:
  - url: https://api.getpostman.com
    description: https://api.getpostman.com
  - url: https://api.eu.postman.com
    description: https://api.eu.postman.com
components:
  schemas:
    collectionUid:
      type: string
      format: uid
      title: collectionUid
    specId:
      type: string
      title: specId
    generateTaskResponse:
      type: object
      properties:
        taskId:
          type: string
          description: >-
            The created task ID. You can use this ID to track the status of the
            task.
        url:
          type: string
          description: The URL to get or poll the status of a generated spec task.
      title: generateTaskResponse
    CommonErrorTypeTitleDetailDetail:
      oneOf:
        - type: string
        - type: object
          additionalProperties:
            description: Any type
      description: Information about the error.
      title: CommonErrorTypeTitleDetailDetail
    commonErrorTypeTitleDetail:
      type: object
      properties:
        type:
          type: string
          description: The type of error.
        title:
          type: string
          description: A short summary of the problem.
        detail:
          $ref: '#/components/schemas/CommonErrorTypeTitleDetailDetail'
          description: Information about the error.
      title: commonErrorTypeTitleDetail
    CommonErrorTypeTitleDetailStatusType:
      oneOf:
        - type: string
          format: uri-reference
        - type: string
      title: CommonErrorTypeTitleDetailStatusType
    commonErrorTypeTitleDetailStatus:
      type: object
      properties:
        type:
          $ref: '#/components/schemas/CommonErrorTypeTitleDetailStatusType'
        title:
          type: string
          description: A short summary of the problem.
        detail:
          type: string
          description: Information about the error.
        status:
          type: integer
          description: The error's HTTP status code.
      title: commonErrorTypeTitleDetailStatus
    commonErrorTypeTitleMessageDetail:
      type: object
      properties:
        type:
          type: string
          description: The type of error.
        title:
          type: string
          description: A short summary of the problem.
        message:
          type: string
          description: The error message.
        detail:
          type: object
          additionalProperties:
            description: Any type
          description: Information about the error.
      title: commonErrorTypeTitleMessageDetail
    SyncCollectionWithSpecRequestForbiddenError:
      oneOf:
        - $ref: '#/components/schemas/commonErrorTypeTitleDetail'
        - $ref: '#/components/schemas/commonErrorTypeTitleDetailStatus'
        - $ref: '#/components/schemas/commonErrorTypeTitleMessageDetail'
      title: SyncCollectionWithSpecRequestForbiddenError
  securitySchemes:
    PostmanApiKey:
      type: apiKey
      in: header
      name: x-api-key
    scimApiKey:
      type: apiKey
      in: header
      name: Authorization
      description: >-
        A valid [SCIM API
        key](https://learning.postman.com/docs/administration/scim-provisioning/scim-provisioning-overview/#generating-scim-api-key)
        for calls to SCIM endpoints.
    basicAuth:
      type: http
      scheme: basic

```

## Examples

### Generate Spec Task



**Response**

```json
{
  "taskId": "66ae9950-0869-4e65-96b0-1e0e47e771af",
  "url": "/specs/73e15000-bc7a-4802-b80e-05fff18fd7f8/tasks/66ae9950-0869-4e65-96b0-1e0e47e771af"
}
```

**SDK Code**

```python Generate Spec Task
import requests

url = "https://api.getpostman.com/collections/12345678-12ece9e1-2abf-4edc-8e34-de66e74114d2/synchronizations"

querystring = {"specId":"73e15000-bc7a-4802-b80e-05fff18fd7f8"}

headers = {"x-api-key": "<apiKey>"}

response = requests.put(url, headers=headers, params=querystring)

print(response.json())
```

```javascript Generate Spec Task
const url = 'https://api.getpostman.com/collections/12345678-12ece9e1-2abf-4edc-8e34-de66e74114d2/synchronizations?specId=73e15000-bc7a-4802-b80e-05fff18fd7f8';
const options = {method: 'PUT', headers: {'x-api-key': '<apiKey>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Generate Spec Task
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.getpostman.com/collections/12345678-12ece9e1-2abf-4edc-8e34-de66e74114d2/synchronizations?specId=73e15000-bc7a-4802-b80e-05fff18fd7f8"

	req, _ := http.NewRequest("PUT", url, nil)

	req.Header.Add("x-api-key", "<apiKey>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Generate Spec Task
require 'uri'
require 'net/http'

url = URI("https://api.getpostman.com/collections/12345678-12ece9e1-2abf-4edc-8e34-de66e74114d2/synchronizations?specId=73e15000-bc7a-4802-b80e-05fff18fd7f8")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Put.new(url)
request["x-api-key"] = '<apiKey>'

response = http.request(request)
puts response.read_body
```

```java Generate Spec Task
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.put("https://api.getpostman.com/collections/12345678-12ece9e1-2abf-4edc-8e34-de66e74114d2/synchronizations?specId=73e15000-bc7a-4802-b80e-05fff18fd7f8")
  .header("x-api-key", "<apiKey>")
  .asString();
```

```php Generate Spec Task
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PUT', 'https://api.getpostman.com/collections/12345678-12ece9e1-2abf-4edc-8e34-de66e74114d2/synchronizations?specId=73e15000-bc7a-4802-b80e-05fff18fd7f8', [
  'headers' => [
    'x-api-key' => '<apiKey>',
  ],
]);

echo $response->getBody();
```

```csharp Generate Spec Task
using RestSharp;

var client = new RestClient("https://api.getpostman.com/collections/12345678-12ece9e1-2abf-4edc-8e34-de66e74114d2/synchronizations?specId=73e15000-bc7a-4802-b80e-05fff18fd7f8");
var request = new RestRequest(Method.PUT);
request.AddHeader("x-api-key", "<apiKey>");
IRestResponse response = client.Execute(request);
```

```swift Generate Spec Task
import Foundation

let headers = ["x-api-key": "<apiKey>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.getpostman.com/collections/12345678-12ece9e1-2abf-4edc-8e34-de66e74114d2/synchronizations?specId=73e15000-bc7a-4802-b80e-05fff18fd7f8")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PUT"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```

### Generate Collection Task



**Response**

```json
{
  "taskId": "66ae9950-0869-4e65-96b0-1e0e47e771af",
  "url": "/collections/12345678-12ece9e1-2abf-4edc-8e34-de66e74114d2/tasks/66ae9950-0869-4e65-96b0-1e0e47e771af"
}
```

**SDK Code**

```python Generate Collection Task
import requests

url = "https://api.getpostman.com/collections/12345678-12ece9e1-2abf-4edc-8e34-de66e74114d2/synchronizations"

querystring = {"specId":"73e15000-bc7a-4802-b80e-05fff18fd7f8"}

headers = {"x-api-key": "<apiKey>"}

response = requests.put(url, headers=headers, params=querystring)

print(response.json())
```

```javascript Generate Collection Task
const url = 'https://api.getpostman.com/collections/12345678-12ece9e1-2abf-4edc-8e34-de66e74114d2/synchronizations?specId=73e15000-bc7a-4802-b80e-05fff18fd7f8';
const options = {method: 'PUT', headers: {'x-api-key': '<apiKey>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Generate Collection Task
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.getpostman.com/collections/12345678-12ece9e1-2abf-4edc-8e34-de66e74114d2/synchronizations?specId=73e15000-bc7a-4802-b80e-05fff18fd7f8"

	req, _ := http.NewRequest("PUT", url, nil)

	req.Header.Add("x-api-key", "<apiKey>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Generate Collection Task
require 'uri'
require 'net/http'

url = URI("https://api.getpostman.com/collections/12345678-12ece9e1-2abf-4edc-8e34-de66e74114d2/synchronizations?specId=73e15000-bc7a-4802-b80e-05fff18fd7f8")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Put.new(url)
request["x-api-key"] = '<apiKey>'

response = http.request(request)
puts response.read_body
```

```java Generate Collection Task
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.put("https://api.getpostman.com/collections/12345678-12ece9e1-2abf-4edc-8e34-de66e74114d2/synchronizations?specId=73e15000-bc7a-4802-b80e-05fff18fd7f8")
  .header("x-api-key", "<apiKey>")
  .asString();
```

```php Generate Collection Task
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PUT', 'https://api.getpostman.com/collections/12345678-12ece9e1-2abf-4edc-8e34-de66e74114d2/synchronizations?specId=73e15000-bc7a-4802-b80e-05fff18fd7f8', [
  'headers' => [
    'x-api-key' => '<apiKey>',
  ],
]);

echo $response->getBody();
```

```csharp Generate Collection Task
using RestSharp;

var client = new RestClient("https://api.getpostman.com/collections/12345678-12ece9e1-2abf-4edc-8e34-de66e74114d2/synchronizations?specId=73e15000-bc7a-4802-b80e-05fff18fd7f8");
var request = new RestRequest(Method.PUT);
request.AddHeader("x-api-key", "<apiKey>");
IRestResponse response = client.Execute(request);
```

```swift Generate Collection Task
import Foundation

let headers = ["x-api-key": "<apiKey>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.getpostman.com/collections/12345678-12ece9e1-2abf-4edc-8e34-de66e74114d2/synchronizations?specId=73e15000-bc7a-4802-b80e-05fff18fd7f8")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PUT"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```